#ifndef LCRZOEX_LCRZOEX_INCLUDED
#define LCRZOEX_LCRZOEX_INCLUDED 1

/*-------------------------------------------------------------*/
typedef struct
{ lcrzo_conststring refname;
  lcrzo_uint32      refvalue;
  lcrzo_uint8       majorversion;
  lcrzo_uint8       minorversion;
  lcrzo_conststring title_en;
  lcrzo_conststring title_fr;
  lcrzo_conststring description_en;
  lcrzo_conststring description_fr;
  lcrzo_conststring usage_en;
  lcrzo_conststring usage_fr;
  lcrzo_conststring usageex_en;
  lcrzo_conststring usageex_fr;
  lcrzo_conststring author;
} shared_lcrzoex_infos;

/*en print information about an tool */
/*fr affiche les informations sur un outil */
int shared_lcrzoex_infos_fprint(LCRZOFILE *pf,
				shared_lcrzoex_infos infos,
				lcrzo_conststring progname);
#define shared_lcrzoex_infos_print(i,p) shared_lcrzoex_infos_fprint(stdout,i,p)

/*en redirect an old tool */
/*fr redirige un ancien exemple, vers un nouvel outil*/
int shared_lcrzoex_infos_redirect_print(shared_lcrzoex_infos old,
					shared_lcrzoex_infos newi);

/*-------------------------------------------------------------*/
int shared_lcrzoex__x_main(int ac, 
			   char* av[], 
			   lcrzo_uint32 toolnumber);
int shared_lcrzoex__x_infos(lcrzo_uint32 toolnumber,
			    shared_lcrzoex_infos *pinfos);

/*-------------------------------------------------------------*/
int shared_lcrzoex_tool_unknown_print(lcrzo_uint32 toolnumber);
int shared_lcrzoex_tool_usage_print(lcrzo_conststring progname,
				    lcrzo_uint32 toolnumber);
int shared_lcrzoex_tool_get_title(lcrzo_uint32 toolnumber,
				  lcrzo_int16 language,
				  lcrzo_string *ptitle);
int shared_lcrzoex_tool_get_max(lcrzo_uint32 *pmaxtoolnumber);

/*-------------------------------------------------------------*/
typedef struct {
  lcrzo_list list;
  lcrzo_int16 language;
  lcrzo_int16 level;
  lcrzo_uint8 c;
} shared_lcrzoex_helpmode_cat;
int shared_lcrzoex_helpmode_cat_init(shared_lcrzoex_helpmode_cat *pcat,
				     lcrzo_int16 language,
				     lcrzo_int16 level);
int shared_lcrzoex_helpmode_cat_add(shared_lcrzoex_helpmode_cat *pcat,
				    lcrzo_uint32 toolnumber);
int shared_lcrzoex_helpmode_cat_close(shared_lcrzoex_helpmode_cat *pcat,
				      lcrzo_string levels, 
				      lcrzo_uint32 *ptoolnumber);

/*-------------------------------------------------------------*/
typedef struct {
  lcrzo_int16 language;
  lcrzo_int16 level;
  lcrzo_uint8 c;
} shared_lcrzoex_helpmode_catheader;
int shared_lcrzoex_helpmode_catheader_init(shared_lcrzoex_helpmode_catheader *pcatheader,
					   lcrzo_int16 language,
					   lcrzo_int16 level);
int shared_lcrzoex_helpmode_catheader_add(shared_lcrzoex_helpmode_catheader *pcatheader,
					   lcrzo_conststring frstr,
					   lcrzo_conststring enstr);
int shared_lcrzoex_helpmode_catheader_close(shared_lcrzoex_helpmode_catheader *pcatheader,
					    lcrzo_string levels);

/*-------------------------------------------------------------*/
int shared_lcrzoex_helpmode_mainmenu(lcrzo_int16 language,
				     lcrzo_string levels);

/*-------------------------------------------------------------*/
int shared_lcrzoex_tool_search(void);
int shared_lcrzoex_tool_savefile(void);

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_PROCESSOTHEREXIT_WARN==1
 /* This function is only used in debugging mode.
    You can ignore it. */
 int shared_lcrzoex_debug_processotherexit_wanttowarn(lcrzo_bool yes);
#else
 #define shared_lcrzoex_debug_processotherexit_wanttowarn(a) LCRZO_ERR_OK;
#endif

#endif

